#ifndef MYBUFFER_ALDABA_WASMLIB_H
#define MYBUFFER_ALDABA_WASMLIB_H

#include <cstdarg>
#include <string>

#include "mybuffer/aldabalib.h"

class AldabaCSOLib : public AldabaLib {
 public:
  AldabaCSOLib(const aldaba::StaticString &root_tag) : root_tag_(root_tag) {}

  ~AldabaCSOLib() final = default;

 protected:
  int MyGetStorageInternal(const std::string &key, std::string &val) override {
    return aldaba::internal::get_shared_extended_mb(root_tag_, key, val);
  }

  int MySetStorageInternal(const std::string &key,
                           const std::string &val) override {
    return aldaba::internal::set_shared_extended_mb(root_tag_, key, val);
  }

  int MyDelStorageInternal(const std::string &key) override {
    return aldaba::internal::del_shared_extended_mb(root_tag_, key);
  }

 private:
  const aldaba::StaticString root_tag_;
};

class AldabaCSBLib : public AldabaLib {
 public:
  AldabaCSBLib(const aldaba::Account &account) : account_(account) {}

  ~AldabaCSBLib() final = default;

 protected:
  int MyGetStorageInternal(const std::string &key, std::string &val) override {
    return aldaba::internal::get_private_extended_mb(account_, key, val);
  }

  int MySetStorageInternal(const std::string &key,
                           const std::string &val) override {
    return aldaba::internal::set_private_extended_mb(account_, key, val);
  }

  int MyDelStorageInternal(const std::string &key) override {
    return aldaba::internal::del_private_extended_mb(account_, key);
  }

 private:
  const aldaba::Account account_;
};

#endif  // MYBUFFER_ALDABA_WASMLIB_H