#ifndef MYBUFFER_LOG_H
#define MYBUFFER_LOG_H

#include <map>
#include <string>

// MYBUFFER_LOG_LEVEL_FATAL, MYBUFFER_LOG_LEVEL_ERROR, MYBUFFER_LOG_LEVEL_WARNING, 
// MYBUFFER_LOG_LEVEL_INFO, MYBUFFER_LOG_LEVEL_DEBUG
// can be defined via the command line, such as -LOG_LEVEL_WARNING
// If none of them are defined, set log level to info level by default
#if defined(MYBUFFER_LOG_LEVEL_FATAL)
    #define MYBUFFER_LOG_LEVEL LogLevel::kFatal
#elif defined(MYBUFFER_LOG_LEVEL_ERROR)
    #define MYBUFFER_LOG_LEVEL LogLevel::kError
#elif defined(MYBUFFER_LOG_LEVEL_WARNING)
    #define MYBUFFER_LOG_LEVEL LogLevel::kWarning
#elif defined(MYBUFFER_LOG_LEVEL_INFO)
    #define MYBUFFER_LOG_LEVEL LogLevel::kInfo
#elif defined(MYBUFFER_LOG_LEVEL_DEBUG)
    #define MYBUFFER_LOG_LEVEL LogLevel::kDebug
#else
    #define MYBUFFER_LOG_LEVEL LogLevel::kInfo
#endif

#define LOGGER_BUFFER_SIZE 1024

enum class LogLevel {
    kDebug = 0,
    kInfo = 1,
    kWarning = 2,
    kError = 3,
    kFatal = 4,
};

static std::map<LogLevel, std::string> kLevelPrefixMap = {
    {LogLevel::kDebug,      "[mybuffer:debug] "},
    {LogLevel::kInfo,       "[mybuffer:info] "},
    {LogLevel::kWarning,    "[mybuffer:warning] "},
    {LogLevel::kError,      "[mybuffer:error] "},
    {LogLevel::kFatal,      "[mybuffer:fatal] "}
};

#endif // MYBUFFER_LOG_H
