#ifndef MYBUFFER_H
#define MYBUFFER_H

#include "mybuffer/mybuffer_mytable.h"
#include "mybuffer/mybuffer_myvector.h"
#include "mybuffer/mybuffer_mymap.h"
#include "mybuffer/mybuffer_mymapiterable.h"

// using namespace mychain;

/*
inline int GetKV(const std::string &key, std::string &val) {
    int rv = GetStorage(key, val);
    if (rv != MychainApiErrors::ERROR_NONE &&
        rv != MychainApiErrors::ERROR_DEPRECATING &&
        rv != MychainApiErrors::ERROR_KEY_DELETED &&
        rv != MychainApiErrors::ERROR_KEY_NOT_EXISTS) {
        if (rv == MychainApiErrors::ERROR_OVER_SIZE) {
            Revert("Object key is over the 1KB limit.");
        } else {
            Revert("Internal get-kv error: " + std::to_string(rv));
        }
    }
    return rv;
}

inline int SetKV(const std::string &key, const std::string &val) {
    int rv = SetStorage(key, val);
    if (rv != MychainApiErrors::ERROR_NONE) {
        if (rv == MychainApiErrors::ERROR_OVER_SIZE) {
            Revert("Object key/value is oversized.");
        } else {
            Revert("Internal set-kv error: " + std::to_string(rv));
        }
    }
    return rv;
}

inline int DelKV(const std::string &key) {
    int rv = DeleteStorage(key);
    if (rv != MychainApiErrors::ERROR_NONE) {
        if (rv == MychainApiErrors::ERROR_NO_OBJECT) {
            Revert("Failed to delete a non-existing object.");
        } else {
            Revert("Internal del-kv error: " + std::to_string(rv));
        }
    }
    return rv;
}*/

struct DataContractMetaM : public MyTable<DataContractMetaT, DataContractMeta> {
private:
  using MyTable<DataContractMetaT, DataContractMeta>::MyTable;
  friend class MyFactory<DataContractMetaM, DataContractMetaT>;
  friend class MyFactory<DataContractMetaM>;
public:
  ~DataContractMetaM() {}
  std::string get_data_contract_id() {
    return native_table_ptr_->data_contract_id;
  }
  bool set_data_contract_id(std::string _data_contract_id) {
    uint32_t size_limit = 0 ? 0 : kDefaultStringSizeLimit;
    if( _data_contract_id.length() > size_limit ) {
        std::string msg = "The string size is over the limit" + std::to_string(size_limit);
        mychain_lib_ptr_->MYLOG(LogLevel::kError, msg);
        mychain_lib_ptr_->MyRevert(msg);
    }
    set_dirty(true);
    native_table_ptr_->data_contract_id = std::move(_data_contract_id);
    return true;
  }
  uint32_t get_data_contract_database_id() {
    return native_table_ptr_->data_contract_database_id;
  }
  bool set_data_contract_database_id(uint32_t _data_contract_database_id) {
    set_dirty(true);
    native_table_ptr_->data_contract_database_id = _data_contract_database_id;
    return true;
  }
};
#endif // MYBUFFER_H
