/**
 * Copyright 2018 Ant Financial Group. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0(the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Author : dongwei.ldw@antfin.com
 * Date : 2018-12-28
 */

#pragma once
#include <string>
#include "serialize.hpp"

// namespace std::string_literals only contains operator ""s, hardly conflict with
// user's namespace and operator ""s is such a common need, so that we include it by
// default.
using namespace std::string_literals;

namespace mychain {

#define STORAGE_LIMIT (1024 * 1024)

constexpr size_t HashLength = 32;
constexpr size_t IdentityLength = 32;

enum ACCOUNT_STATUS : uint32_t { NORMAL = 0, FREEZE, RECOVERING };
enum EXECUTE_STATUS : int32_t { SUCCESS = 0, NOTFOUND = -1 };
enum DigestType : uint16_t { NOHASH = 0, SHA256 = 1, SM3 = 2, KECCAK = 3, SHA1 = 4 };

}  // namespace mychain
